﻿/*************************** 
 * Demo_Eye_Tracking2 Test *
 ***************************/


// store info about the experiment session:
let expName = 'demo_eye_tracking2';  // from the Builder filename that created this script
let expInfo = {
    'participant': '',
    'session': '001',
};

// Start code blocks for 'Before Experiment'
// init psychoJS:
const psychoJS = new PsychoJS({
  debug: true
});

// open window:
psychoJS.openWindow({
  fullscr: true,
  color: new util.Color([0, 0, 0]),
  units: 'height',
  waitBlanking: true
});
// schedule the experiment:
psychoJS.schedule(psychoJS.gui.DlgFromDict({
  dictionary: expInfo,
  title: expName
}));

const flowScheduler = new Scheduler(psychoJS);
const dialogCancelScheduler = new Scheduler(psychoJS);
psychoJS.scheduleCondition(function() { return (psychoJS.gui.dialogComponent.button === 'OK'); }, flowScheduler, dialogCancelScheduler);

// flowScheduler gets run if the participants presses OK
flowScheduler.add(updateInfo); // add timeStamp
flowScheduler.add(experimentInit);
flowScheduler.add(loading_trialRoutineBegin());
flowScheduler.add(loading_trialRoutineEachFrame());
flowScheduler.add(loading_trialRoutineEnd());
flowScheduler.add(webcam_trialRoutineBegin());
flowScheduler.add(webcam_trialRoutineEachFrame());
flowScheduler.add(webcam_trialRoutineEnd());
flowScheduler.add(intro_calibatrion_trialRoutineBegin());
flowScheduler.add(intro_calibatrion_trialRoutineEachFrame());
flowScheduler.add(intro_calibatrion_trialRoutineEnd());
const trialsLoopScheduler = new Scheduler(psychoJS);
flowScheduler.add(trialsLoopBegin(trialsLoopScheduler));
flowScheduler.add(trialsLoopScheduler);
flowScheduler.add(trialsLoopEnd);
flowScheduler.add(Opening_MAPRoutineBegin());
flowScheduler.add(Opening_MAPRoutineEachFrame());
flowScheduler.add(Opening_MAPRoutineEnd());
const MAP_trialsLoopScheduler = new Scheduler(psychoJS);
flowScheduler.add(MAP_trialsLoopBegin(MAP_trialsLoopScheduler));
flowScheduler.add(MAP_trialsLoopScheduler);
flowScheduler.add(MAP_trialsLoopEnd);
flowScheduler.add(End_MAPRoutineBegin());
flowScheduler.add(End_MAPRoutineEachFrame());
flowScheduler.add(End_MAPRoutineEnd());
flowScheduler.add(Opening_SPIRRoutineBegin());
flowScheduler.add(Opening_SPIRRoutineEachFrame());
flowScheduler.add(Opening_SPIRRoutineEnd());
const SPIR_trialsLoopScheduler = new Scheduler(psychoJS);
flowScheduler.add(SPIR_trialsLoopBegin(SPIR_trialsLoopScheduler));
flowScheduler.add(SPIR_trialsLoopScheduler);
flowScheduler.add(SPIR_trialsLoopEnd);
flowScheduler.add(End_SPIRRoutineBegin());
flowScheduler.add(End_SPIRRoutineEachFrame());
flowScheduler.add(End_SPIRRoutineEnd());
flowScheduler.add(quitPsychoJS, '', true);

// quit if user presses Cancel in dialog box:
dialogCancelScheduler.add(quitPsychoJS, '', false);

psychoJS.start({
  expName: expName,
  expInfo: expInfo,
  resources: [
    {'name': 'map_resources/b13_p217_15.jpg', 'path': 'map_resources/b13_p217_15.jpg'},
    {'name': 'map_resources/b10_p139_6.jpg', 'path': 'map_resources/b10_p139_6.jpg'},
    {'name': 'map_resources/b2_p17_9.jpg', 'path': 'map_resources/b2_p17_9.jpg'},
    {'name': 'pic_test_map.xlsx', 'path': 'pic_test_map.xlsx'},
    {'name': 'calibration_trials.xlsx', 'path': 'calibration_trials.xlsx'},
    {'name': 'map_resources/b5_p82_6.jpg', 'path': 'map_resources/b5_p82_6.jpg'},
    {'name': 'map_resources/b13_p218_12.jpg', 'path': 'map_resources/b13_p218_12.jpg'},
    {'name': 'pic_test_spir.xlsx', 'path': 'pic_test_spir.xlsx'},
    {'name': 'map_resources/mask.jpg', 'path': 'map_resources/mask.jpg'},
    {'name': 'map_resources/b7_p103_5.jpg', 'path': 'map_resources/b7_p103_5.jpg'}
  ]
});

psychoJS.experimentLogger.setLevel(core.Logger.ServerLevel.EXP);


var currentLoop;
var frameDur;
async function updateInfo() {
  currentLoop = psychoJS.experiment;  // right now there are no loops
  expInfo['date'] = util.MonotonicClock.getDateStr();  // add a simple timestamp
  expInfo['expName'] = expName;
  expInfo['psychopyVersion'] = '2022.2.4';
  expInfo['OS'] = window.navigator.platform;

  psychoJS.experiment.dataFileName = (("." + "/") + `data/${expInfo["participant"]}_${expName}_${expInfo["date"]}`);

  // store frame rate of monitor if we can measure it successfully
  expInfo['frameRate'] = psychoJS.window.getActualFrameRate();
  if (typeof expInfo['frameRate'] !== 'undefined')
    frameDur = 1.0 / Math.round(expInfo['frameRate']);
  else
    frameDur = 1.0 / 60.0; // couldn't get a reliable measure so guess

  // add info from the URL:
  util.addInfoFromUrl(expInfo);
  
  return Scheduler.Event.NEXT;
}


var loading_trialClock;
var loading_text;
var webcam_trialClock;
var intro_text;
var intro_calibatrion_trialClock;
var calibration_text;
var mouse_2;
var calibration_trialClock;
var calibration_square;
var mouse_3;
var Opening_MAPClock;
var key_resp;
var Instruct;
var tracking_square_2;
var Image_MAPClock;
var map_image;
var isi_crosshair;
var tracking_square_3;
var backward_maskClock;
var noise_img;
var tracking_square_4;
var rate_moral_MAPClock;
var moral_prompt;
var slider;
var moral_left;
var moral_right;
var key_resp_2;
var enter_prompt;
var tracking_square_5;
var rate_confidence_MAPClock;
var moral_confidence;
var slider_2;
var conf_left;
var conf_right;
var key_resp_3;
var enter_prompt2;
var tracking_square_6;
var End_MAPClock;
var text;
var key_resp_4;
var Opening_SPIRClock;
var inst_SPIR;
var key_resp_5;
var rating_SPIRClock;
var moral_prompt_2;
var moral_slider;
var moral_left_2;
var moral_right_2;
var key_resp_6;
var enter_prompt_2;
var valence_left;
var valence_right;
var valence_slider;
var arous_left;
var arous_right;
var arous_slider;
var image_spir;
var End_SPIRClock;
var text_2;
var key_resp_7;
var globalClock;
var routineTimer;
async function experimentInit() {
  // Initialize components for Routine "loading_trial"
  loading_trialClock = new util.Clock();
  // Download the webgazer library and re-download seedrandom.js (since webgazer
  // overrides it with a version that conflicts with PsychoJS)
  psychoJS.downloadResources([
    { name: 'webgazer.js', path: 'js/webgazer-2.0.1.tp.js' },
    { name: 'seedrandom.js', path: 'https://cdnjs.cloudflare.com/ajax/libs/seedrandom/3.0.1/seedrandom.min.js' }
  ]);
  // Initialize x and y arrays; we use these to calculate running averages of 
  // current gaze position; the longer the window, the slower, but more fluent
  // the updates
  let averagingWindow = 10;
  window.xGazes = new Array(averagingWindow ).fill(0);
  window.yGazes = new Array(averagingWindow ).fill(0);
  // Timestamp for last time eyes exited validation box
  window.eyesExitedTimestamp= (new Date).getTime();
  // No. of ms to keep webcam thumbnail visible after eyes returned into validation box
  window.eyesReturnedDelay = 3000;
  // DEBUG
  window.psychoJS = psychoJS;
  loading_text = new visual.TextStim({
    win: psychoJS.window,
    name: 'loading_text',
    text: 'Downloading additional resources. \n\nOne moment please...',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.1,  wrapWidth: undefined, ori: 0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: 1,
    depth: -1.0 
  });
  
  // Initialize components for Routine "webcam_trial"
  webcam_trialClock = new util.Clock();
  intro_text = new visual.TextStim({
    win: psychoJS.window,
    name: 'intro_text',
    text: 'demo_eye_tracking: starting webcam\n\nThis experiment demonstrates eye tracking via the webgazer library. \n\nYou should see your web-browser request access to your webcam. You might need to click on this text to make that happen. Please permit access, and wait a little while. Your webcam video should appear in the top-left of the screen.',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.04,  wrapWidth: undefined, ori: 0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  // Initialize components for Routine "intro_calibatrion_trial"
  intro_calibatrion_trialClock = new util.Clock();
  calibration_text = new visual.TextStim({
    win: psychoJS.window,
    name: 'calibration_text',
    text: "demo_eye_tracking: calibration\n\nNow we'll calibrate the eye tracker. Please try to keep your head still and within the rectangle you see in your webcam video. When you do so, the rectangle turns green.\n\nIn the next part of this experiment, the webcam video disappears. It will reappear when your head is too from the rectangle. If this happens, please move back into view. White squares appears at different locations on the screen. Please click each square with your mouse.\n\nClick anywhere to continue...",
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.04,  wrapWidth: undefined, ori: 0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  mouse_2 = new core.Mouse({
    win: psychoJS.window,
  });
  mouse_2.mouseClock = new util.Clock();
  // Initialize components for Routine "calibration_trial"
  calibration_trialClock = new util.Clock();
  calibration_square = new visual.Rect ({
    win: psychoJS.window, name: 'calibration_square', 
    width: [0.02, 0.02][0], height: [0.02, 0.02][1],
    ori: 0, pos: [0, 0],
    lineWidth: 0, 
    colorSpace: 'rgb',
    lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: 0, interpolate: true,
  });
  
  mouse_3 = new core.Mouse({
    win: psychoJS.window,
  });
  mouse_3.mouseClock = new util.Clock();
  // Initialize components for Routine "Opening_MAP"
  Opening_MAPClock = new util.Clock();
  key_resp = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  Instruct = new visual.TextStim({
    win: psychoJS.window,
    name: 'Instruct',
    text: "Instructions:\n\n\nYou will see a series of pictures, each presented very briefly.\n\nYou will then be asked to answer two questions about each image.\n\nPlease answer each question to the best of your ability, even if you aren't sure.\n\nIT IS VERY IMPORTANT THAT YOU GIVE YOUR UNDIVIDED ATTENTION TO THIS TASK.\n\nPress the Spacebar to Begin",
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: 1.5, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: undefined,
    depth: -1.0 
  });
  
  tracking_square_2 = new visual.Rect ({
    win: psychoJS.window, name: 'tracking_square_2', 
    width: [0.02, 0.02][0], height: [0.02, 0.02][1],
    ori: 0, pos: [0, 0],
    lineWidth: undefined, 
    colorSpace: 'rgb',
    lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([(- 1), (- 1), (- 1)]),
    opacity: 1, depth: -3, interpolate: true,
  });
  
  // Initialize components for Routine "Image_MAP"
  Image_MAPClock = new util.Clock();
  map_image = new visual.ImageStim({
    win : psychoJS.window,
    name : 'map_image', units : undefined, 
    image : undefined, mask : undefined,
    ori : 0.0, pos : [0, 0], size : [1, 1],
    color : new util.Color([1,1,1]), opacity : undefined,
    flipHoriz : false, flipVert : false,
    texRes : 128.0, interpolate : true, depth : 0.0 
  });
  isi_crosshair = new visual.TextStim({
    win: psychoJS.window,
    name: 'isi_crosshair',
    text: '+',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.3,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: undefined,
    depth: -1.0 
  });
  
  tracking_square_3 = new visual.Rect ({
    win: psychoJS.window, name: 'tracking_square_3', 
    width: [0.02, 0.02][0], height: [0.02, 0.02][1],
    ori: 0, pos: [0, 0],
    lineWidth: undefined, 
    colorSpace: 'rgb',
    lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([(- 1), (- 1), (- 1)]),
    opacity: 1, depth: -3, interpolate: true,
  });
  
  // Initialize components for Routine "backward_mask"
  backward_maskClock = new util.Clock();
  noise_img = new visual.ImageStim({
    win : psychoJS.window,
    name : 'noise_img', units : undefined, 
    image : 'map_resources/mask.jpg', mask : undefined,
    ori : 0.0, pos : [0, 0], size : [1, 1],
    color : new util.Color([1,1,1]), opacity : undefined,
    flipHoriz : false, flipVert : false,
    texRes : 128.0, interpolate : true, depth : 0.0 
  });
  tracking_square_4 = new visual.Rect ({
    win: psychoJS.window, name: 'tracking_square_4', 
    width: [0.02, 0.02][0], height: [0.02, 0.02][1],
    ori: 0, pos: [0, 0],
    lineWidth: undefined, 
    colorSpace: 'rgb',
    lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([(- 1), (- 1), (- 1)]),
    opacity: 1, depth: -1, interpolate: true,
  });
  
  // Initialize components for Routine "rate_moral_MAP"
  rate_moral_MAPClock = new util.Clock();
  moral_prompt = new visual.TextStim({
    win: psychoJS.window,
    name: 'moral_prompt',
    text: 'The image you just saw was...',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0.2], height: 0.1,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: undefined,
    depth: 0.0 
  });
  
  slider = new visual.Slider({
    win: psychoJS.window, name: 'slider',
    startValue: 3,
    size: [1.0, 0.1], pos: [0, (- 0.2)], ori: 0.0, units: 'height',
    labels: undefined, fontSize: 0.05, ticks: [1, 5],
    granularity: 0.0, style: ["SLIDER", "LABELS_45"],
    color: new util.Color('LightGray'), markerColor: new util.Color('Red'), lineColor: new util.Color('White'), 
    opacity: undefined, fontFamily: 'Open Sans', bold: true, italic: false, depth: -1, 
    flip: false,
  });
  
  moral_left = new visual.TextStim({
    win: psychoJS.window,
    name: 'moral_left',
    text: 'Immoral\n\n\nBlameworthy',
    font: 'Open Sans',
    units: undefined, 
    pos: [(- 0.5), (- 0.2)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: undefined,
    depth: -2.0 
  });
  
  moral_right = new visual.TextStim({
    win: psychoJS.window,
    name: 'moral_right',
    text: 'Moral\n\n\nPraiseworthy',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.5, (- 0.2)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: undefined,
    depth: -3.0 
  });
  
  key_resp_2 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  enter_prompt = new visual.TextStim({
    win: psychoJS.window,
    name: 'enter_prompt',
    text: '(Press SPACE BAR to submit your rating)',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, (- 0.4)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: undefined,
    depth: -5.0 
  });
  
  tracking_square_5 = new visual.Rect ({
    win: psychoJS.window, name: 'tracking_square_5', 
    width: [0.02, 0.02][0], height: [0.02, 0.02][1],
    ori: 0, pos: [0, 0],
    lineWidth: undefined, 
    colorSpace: 'rgb',
    lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([(- 1), (- 1), (- 1)]),
    opacity: 1, depth: -6, interpolate: true,
  });
  
  // Initialize components for Routine "rate_confidence_MAP"
  rate_confidence_MAPClock = new util.Clock();
  moral_confidence = new visual.TextStim({
    win: psychoJS.window,
    name: 'moral_confidence',
    text: 'How confident are you about the rating you just gave?',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0.2], height: 0.1,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: undefined,
    depth: 0.0 
  });
  
  slider_2 = new visual.Slider({
    win: psychoJS.window, name: 'slider_2',
    startValue: 3,
    size: [1.0, 0.02], pos: [0, (- 0.2)], ori: 0.0, units: 'height',
    labels: undefined, fontSize: 0.05, ticks: [1, 5],
    granularity: 0.0, style: ["SLIDER", "LABELS_45"],
    color: new util.Color('LightGray'), markerColor: new util.Color('Red'), lineColor: new util.Color('White'), 
    opacity: undefined, fontFamily: 'Open Sans', bold: true, italic: false, depth: -1, 
    flip: false,
  });
  
  conf_left = new visual.TextStim({
    win: psychoJS.window,
    name: 'conf_left',
    text: 'Not Confident At All\n\n\n\nAbsolute Guess',
    font: 'Open Sans',
    units: undefined, 
    pos: [(- 0.5), (- 0.2)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: undefined,
    depth: -2.0 
  });
  
  conf_right = new visual.TextStim({
    win: psychoJS.window,
    name: 'conf_right',
    text: 'Confident\n\n\nCompletely Sure',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.5, (- 0.2)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: undefined,
    depth: -3.0 
  });
  
  key_resp_3 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  enter_prompt2 = new visual.TextStim({
    win: psychoJS.window,
    name: 'enter_prompt2',
    text: '(Press SPACE BAR to submit your rating)',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, (- 0.4)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: undefined,
    depth: -5.0 
  });
  
  tracking_square_6 = new visual.Rect ({
    win: psychoJS.window, name: 'tracking_square_6', 
    width: [0.02, 0.02][0], height: [0.02, 0.02][1],
    ori: 0, pos: [0, 0],
    lineWidth: undefined, 
    colorSpace: 'rgb',
    lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([(- 1), (- 1), (- 1)]),
    opacity: 1, depth: -6, interpolate: true,
  });
  
  // Initialize components for Routine "End_MAP"
  End_MAPClock = new util.Clock();
  text = new visual.TextStim({
    win: psychoJS.window,
    name: 'text',
    text: 'Press the Spacebar to proceed to the next experiment.',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: 1.5, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: undefined,
    depth: 0.0 
  });
  
  key_resp_4 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "Opening_SPIR"
  Opening_SPIRClock = new util.Clock();
  inst_SPIR = new visual.TextStim({
    win: psychoJS.window,
    name: 'inst_SPIR',
    text: 'Instructions:\n\nYou will see a series of 108 pictures, each alongside three rating scales.\n\nFor each image, rate how calming/exciting, pleasant/unpleasant, and moral/immoral it is by clicking on the rating scale. When you are finished rating a given picture, press "Spacebar" to submit your rating.\n\nPress the Spacebar to Begin',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: 1.5, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: undefined,
    depth: 0.0 
  });
  
  key_resp_5 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "rating_SPIR"
  rating_SPIRClock = new util.Clock();
  moral_prompt_2 = new visual.TextStim({
    win: psychoJS.window,
    name: 'moral_prompt_2',
    text: 'The image you see is...',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.5, 0.4], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: undefined,
    depth: 0.0 
  });
  
  moral_slider = new visual.Slider({
    win: psychoJS.window, name: 'moral_slider',
    startValue: 3,
    size: [0.5, 0.05], pos: [0.5, (- 0.25)], ori: 0.0, units: 'height',
    labels: undefined, fontSize: 0.05, ticks: [1, 5],
    granularity: 0.0, style: ["SLIDER", "LABELS_45"],
    color: new util.Color('LightGray'), markerColor: new util.Color('blueviolet'), lineColor: new util.Color('lavender'), 
    opacity: undefined, fontFamily: 'Open Sans', bold: true, italic: false, depth: -1, 
    flip: false,
  });
  
  moral_left_2 = new visual.TextStim({
    win: psychoJS.window,
    name: 'moral_left_2',
    text: 'Immoral\n\nBlameworthy',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.3, (- 0.25)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('lavender'),  opacity: undefined,
    depth: -2.0 
  });
  
  moral_right_2 = new visual.TextStim({
    win: psychoJS.window,
    name: 'moral_right_2',
    text: 'Moral\n\nPraiseworthy',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.7, (- 0.25)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('lavender'),  opacity: undefined,
    depth: -3.0 
  });
  
  key_resp_6 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  enter_prompt_2 = new visual.TextStim({
    win: psychoJS.window,
    name: 'enter_prompt_2',
    text: '(Press SPACE BAR to submit your rating)',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, (- 0.45)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: undefined,
    depth: -5.0 
  });
  
  valence_left = new visual.TextStim({
    win: psychoJS.window,
    name: 'valence_left',
    text: 'Unpleasant\n\nNegative',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.3, 0], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('lightpink'),  opacity: undefined,
    depth: -6.0 
  });
  
  valence_right = new visual.TextStim({
    win: psychoJS.window,
    name: 'valence_right',
    text: 'Pleasant\n\nPositive',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.7, 0], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('lightpink'),  opacity: undefined,
    depth: -7.0 
  });
  
  valence_slider = new visual.Slider({
    win: psychoJS.window, name: 'valence_slider',
    startValue: 3,
    size: [0.5, 0.05], pos: [0.5, 0], ori: 0.0, units: 'height',
    labels: undefined, fontSize: 0.05, ticks: [1, 5],
    granularity: 0.0, style: ["SLIDER", "LABELS_45"],
    color: new util.Color('LightGray'), markerColor: new util.Color('Red'), lineColor: new util.Color('lightpink'), 
    opacity: undefined, fontFamily: 'Open Sans', bold: true, italic: false, depth: -8, 
    flip: false,
  });
  
  arous_left = new visual.TextStim({
    win: psychoJS.window,
    name: 'arous_left',
    text: 'Calming',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.3, 0.25], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('lemonchiffon'),  opacity: undefined,
    depth: -9.0 
  });
  
  arous_right = new visual.TextStim({
    win: psychoJS.window,
    name: 'arous_right',
    text: 'Exciting',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.7, 0.25], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('lemonchiffon'),  opacity: undefined,
    depth: -10.0 
  });
  
  arous_slider = new visual.Slider({
    win: psychoJS.window, name: 'arous_slider',
    startValue: 3,
    size: [0.5, 0.05], pos: [0.5, 0.2], ori: 0.0, units: 'height',
    labels: undefined, fontSize: 0.05, ticks: [1, 5],
    granularity: 0.0, style: ["SLIDER", "LABELS_45"],
    color: new util.Color('LightGray'), markerColor: new util.Color('darkorange'), lineColor: new util.Color('lemonchiffon'), 
    opacity: undefined, fontFamily: 'Open Sans', bold: true, italic: false, depth: -11, 
    flip: false,
  });
  
  image_spir = new visual.ImageStim({
    win : psychoJS.window,
    name : 'image_spir', units : undefined, 
    image : undefined, mask : undefined,
    ori : 0.0, pos : [(- 0.4), 0.05], size : [0.75, 0.75],
    color : new util.Color([1,1,1]), opacity : undefined,
    flipHoriz : false, flipVert : false,
    texRes : 128.0, interpolate : true, depth : -12.0 
  });
  // Initialize components for Routine "End_SPIR"
  End_SPIRClock = new util.Clock();
  text_2 = new visual.TextStim({
    win: psychoJS.window,
    name: 'text_2',
    text: 'Thank you for your participation\n\nPress Escape or the Spacebar to proceed to exit the experiment and submit your responses for credit.',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: 1.5, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: undefined,
    depth: 0.0 
  });
  
  key_resp_7 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Create some handy timers
  globalClock = new util.Clock();  // to track the time since experiment started
  routineTimer = new util.CountdownTimer();  // to track time remaining of each (non-slip) routine
  
  return Scheduler.Event.NEXT;
}


var t;
var frameN;
var continueRoutine;
var loading_trialComponents;
function loading_trialRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //--- Prepare to start Routine 'loading_trial' ---
    t = 0;
    loading_trialClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    // keep track of which components have finished
    loading_trialComponents = [];
    loading_trialComponents.push(loading_text);
    
    loading_trialComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


function loading_trialRoutineEachFrame() {
  return async function () {
    //--- Loop for each frame of Routine 'loading_trial' ---
    // get current time
    t = loading_trialClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    // Continue once the webgazer global is available
    continueRoutine = !window.hasOwnProperty('webgazer');
    
    // *loading_text* updates
    if (t >= 0.0 && loading_text.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      loading_text.tStart = t;  // (not accounting for frame time here)
      loading_text.frameNStart = frameN;  // exact frame index
      
      loading_text.setAutoDraw(true);
    }

    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    loading_trialComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function loading_trialRoutineEnd(snapshot) {
  return async function () {
    //--- Ending Routine 'loading_trial' ---
    loading_trialComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // the Routine "loading_trial" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    // Routines running outside a loop should always advance the datafile row
    if (currentLoop === psychoJS.experiment) {
      psychoJS.experiment.nextEntry(snapshot);
    }
    return Scheduler.Event.NEXT;
  }
}


var webcam_trialComponents;
function webcam_trialRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //--- Prepare to start Routine 'webcam_trial' ---
    t = 0;
    webcam_trialClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    // Show webcam thumbnail and face feedback box, but not face overlay and gaze dot
    window.webgazer.params.showVideoPreview = true;
    window.webgazer.params.showFaceFeedbackBox = true;
    window.webgazer.params.showFaceOverlay = false;
    window.webgazer.params.showGazeDot = false
    // Start eye tracking
    window.webgazer
        // Called on each eye tracking update
        .setGazeListener(function(data, clock) {
          if (data !== null) {
            // Remove first element from gazes array, add current gaze at the end
            window.xGazes.shift();
            window.xGazes.push(data.x);
            window.yGazes.shift();
            window.yGazes.push(data.y);
           }
        })
        .begin();
        //.showPredictionPoints(true); 
    
    // keep track of which components have finished
    webcam_trialComponents = [];
    webcam_trialComponents.push(intro_text);
    
    webcam_trialComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


function webcam_trialRoutineEachFrame() {
  return async function () {
    //--- Loop for each frame of Routine 'webcam_trial' ---
    // get current time
    t = webcam_trialClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *intro_text* updates
    if (t >= 0.0 && intro_text.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      intro_text.tStart = t;  // (not accounting for frame time here)
      intro_text.frameNStart = frameN;  // exact frame index
      
      intro_text.setAutoDraw(true);
    }

    // Finish routine once everything is ready
    continueRoutine = 
      !window.webgazer.isReady() || 
      document.getElementById('webgazerFaceFeedbackBox') === null ||
      document.getElementById('webgazerVideoFeed') === null;
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    webcam_trialComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function webcam_trialRoutineEnd(snapshot) {
  return async function () {
    //--- Ending Routine 'webcam_trial' ---
    webcam_trialComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // the Routine "webcam_trial" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    // Routines running outside a loop should always advance the datafile row
    if (currentLoop === psychoJS.experiment) {
      psychoJS.experiment.nextEntry(snapshot);
    }
    return Scheduler.Event.NEXT;
  }
}


var gotValidClick;
var intro_calibatrion_trialComponents;
function intro_calibatrion_trialRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //--- Prepare to start Routine 'intro_calibatrion_trial' ---
    t = 0;
    intro_calibatrion_trialClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    // setup some python lists for storing info about the mouse_2
    gotValidClick = false; // until a click is received
    // keep track of which components have finished
    intro_calibatrion_trialComponents = [];
    intro_calibatrion_trialComponents.push(calibration_text);
    intro_calibatrion_trialComponents.push(mouse_2);
    
    intro_calibatrion_trialComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


var prevButtonState;
var _mouseButtons;
function intro_calibatrion_trialRoutineEachFrame() {
  return async function () {
    //--- Loop for each frame of Routine 'intro_calibatrion_trial' ---
    // get current time
    t = intro_calibatrion_trialClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *calibration_text* updates
    if (t >= 0.0 && calibration_text.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      calibration_text.tStart = t;  // (not accounting for frame time here)
      calibration_text.frameNStart = frameN;  // exact frame index
      
      calibration_text.setAutoDraw(true);
    }

    // *mouse_2* updates
    if (t >= 0.0 && mouse_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      mouse_2.tStart = t;  // (not accounting for frame time here)
      mouse_2.frameNStart = frameN;  // exact frame index
      
      mouse_2.status = PsychoJS.Status.STARTED;
      mouse_2.mouseClock.reset();
      prevButtonState = mouse_2.getPressed();  // if button is down already this ISN'T a new click
      }
    if (mouse_2.status === PsychoJS.Status.STARTED) {  // only update if started and not finished!
      _mouseButtons = mouse_2.getPressed();
      if (!_mouseButtons.every( (e,i,) => (e == prevButtonState[i]) )) { // button state changed?
        prevButtonState = _mouseButtons;
        if (_mouseButtons.reduce( (e, acc) => (e+acc) ) > 0) { // state changed to a new click
          // abort routine on response
          continueRoutine = false;
        }
      }
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    intro_calibatrion_trialComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


var _mouseXYs;
function intro_calibatrion_trialRoutineEnd(snapshot) {
  return async function () {
    //--- Ending Routine 'intro_calibatrion_trial' ---
    intro_calibatrion_trialComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // store data for psychoJS.experiment (ExperimentHandler)
    _mouseXYs = mouse_2.getPos();
    _mouseButtons = mouse_2.getPressed();
    psychoJS.experiment.addData('mouse_2.x', _mouseXYs[0]);
    psychoJS.experiment.addData('mouse_2.y', _mouseXYs[1]);
    psychoJS.experiment.addData('mouse_2.leftButton', _mouseButtons[0]);
    psychoJS.experiment.addData('mouse_2.midButton', _mouseButtons[1]);
    psychoJS.experiment.addData('mouse_2.rightButton', _mouseButtons[2]);
    // the Routine "intro_calibatrion_trial" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    // Routines running outside a loop should always advance the datafile row
    if (currentLoop === psychoJS.experiment) {
      psychoJS.experiment.nextEntry(snapshot);
    }
    return Scheduler.Event.NEXT;
  }
}


var trials;
function trialsLoopBegin(trialsLoopScheduler, snapshot) {
  return async function() {
    TrialHandler.fromSnapshot(snapshot); // update internal variables (.thisN etc) of the loop
    
    // set up handler to look after randomisation of conditions etc
    trials = new TrialHandler({
      psychoJS: psychoJS,
      nReps: 1, method: TrialHandler.Method.RANDOM,
      extraInfo: expInfo, originPath: undefined,
      trialList: 'calibration_trials.xlsx',
      seed: undefined, name: 'trials'
    });
    psychoJS.experiment.addLoop(trials); // add the loop to the experiment
    currentLoop = trials;  // we're now the current loop
    
    // Schedule all the trials in the trialList:
    trials.forEach(function() {
      snapshot = trials.getSnapshot();
    
      trialsLoopScheduler.add(importConditions(snapshot));
      trialsLoopScheduler.add(calibration_trialRoutineBegin(snapshot));
      trialsLoopScheduler.add(calibration_trialRoutineEachFrame());
      trialsLoopScheduler.add(calibration_trialRoutineEnd(snapshot));
      trialsLoopScheduler.add(trialsLoopEndIteration(trialsLoopScheduler, snapshot));
    });
    
    return Scheduler.Event.NEXT;
  }
}


async function trialsLoopEnd() {
  // terminate loop
  psychoJS.experiment.removeLoop(trials);
  // update the current loop from the ExperimentHandler
  if (psychoJS.experiment._unfinishedLoops.length>0)
    currentLoop = psychoJS.experiment._unfinishedLoops.at(-1);
  else
    currentLoop = psychoJS.experiment;  // so we use addData from the experiment
  return Scheduler.Event.NEXT;
}


function trialsLoopEndIteration(scheduler, snapshot) {
  // ------Prepare for next entry------
  return async function () {
    if (typeof snapshot !== 'undefined') {
      // ------Check if user ended loop early------
      if (snapshot.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(snapshot);
        }
        scheduler.stop();
      } else {
        psychoJS.experiment.nextEntry(snapshot);
      }
    return Scheduler.Event.NEXT;
    }
  };
}


var MAP_trials;
function MAP_trialsLoopBegin(MAP_trialsLoopScheduler, snapshot) {
  return async function() {
    TrialHandler.fromSnapshot(snapshot); // update internal variables (.thisN etc) of the loop
    
    // set up handler to look after randomisation of conditions etc
    MAP_trials = new TrialHandler({
      psychoJS: psychoJS,
      nReps: 1, method: TrialHandler.Method.RANDOM,
      extraInfo: expInfo, originPath: undefined,
      trialList: 'pic_test_map.xlsx',
      seed: undefined, name: 'MAP_trials'
    });
    psychoJS.experiment.addLoop(MAP_trials); // add the loop to the experiment
    currentLoop = MAP_trials;  // we're now the current loop
    
    // Schedule all the trials in the trialList:
    MAP_trials.forEach(function() {
      snapshot = MAP_trials.getSnapshot();
    
      MAP_trialsLoopScheduler.add(importConditions(snapshot));
      MAP_trialsLoopScheduler.add(Image_MAPRoutineBegin(snapshot));
      MAP_trialsLoopScheduler.add(Image_MAPRoutineEachFrame());
      MAP_trialsLoopScheduler.add(Image_MAPRoutineEnd(snapshot));
      MAP_trialsLoopScheduler.add(backward_maskRoutineBegin(snapshot));
      MAP_trialsLoopScheduler.add(backward_maskRoutineEachFrame());
      MAP_trialsLoopScheduler.add(backward_maskRoutineEnd(snapshot));
      MAP_trialsLoopScheduler.add(rate_moral_MAPRoutineBegin(snapshot));
      MAP_trialsLoopScheduler.add(rate_moral_MAPRoutineEachFrame());
      MAP_trialsLoopScheduler.add(rate_moral_MAPRoutineEnd(snapshot));
      MAP_trialsLoopScheduler.add(rate_confidence_MAPRoutineBegin(snapshot));
      MAP_trialsLoopScheduler.add(rate_confidence_MAPRoutineEachFrame());
      MAP_trialsLoopScheduler.add(rate_confidence_MAPRoutineEnd(snapshot));
      MAP_trialsLoopScheduler.add(MAP_trialsLoopEndIteration(MAP_trialsLoopScheduler, snapshot));
    });
    
    return Scheduler.Event.NEXT;
  }
}


async function MAP_trialsLoopEnd() {
  // terminate loop
  psychoJS.experiment.removeLoop(MAP_trials);
  // update the current loop from the ExperimentHandler
  if (psychoJS.experiment._unfinishedLoops.length>0)
    currentLoop = psychoJS.experiment._unfinishedLoops.at(-1);
  else
    currentLoop = psychoJS.experiment;  // so we use addData from the experiment
  return Scheduler.Event.NEXT;
}


function MAP_trialsLoopEndIteration(scheduler, snapshot) {
  // ------Prepare for next entry------
  return async function () {
    if (typeof snapshot !== 'undefined') {
      // ------Check if user ended loop early------
      if (snapshot.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(snapshot);
        }
        scheduler.stop();
      } else {
        psychoJS.experiment.nextEntry(snapshot);
      }
    return Scheduler.Event.NEXT;
    }
  };
}


var SPIR_trials;
function SPIR_trialsLoopBegin(SPIR_trialsLoopScheduler, snapshot) {
  return async function() {
    TrialHandler.fromSnapshot(snapshot); // update internal variables (.thisN etc) of the loop
    
    // set up handler to look after randomisation of conditions etc
    SPIR_trials = new TrialHandler({
      psychoJS: psychoJS,
      nReps: 1, method: TrialHandler.Method.RANDOM,
      extraInfo: expInfo, originPath: undefined,
      trialList: 'pic_test_spir.xlsx',
      seed: undefined, name: 'SPIR_trials'
    });
    psychoJS.experiment.addLoop(SPIR_trials); // add the loop to the experiment
    currentLoop = SPIR_trials;  // we're now the current loop
    
    // Schedule all the trials in the trialList:
    SPIR_trials.forEach(function() {
      snapshot = SPIR_trials.getSnapshot();
    
      SPIR_trialsLoopScheduler.add(importConditions(snapshot));
      SPIR_trialsLoopScheduler.add(rating_SPIRRoutineBegin(snapshot));
      SPIR_trialsLoopScheduler.add(rating_SPIRRoutineEachFrame());
      SPIR_trialsLoopScheduler.add(rating_SPIRRoutineEnd(snapshot));
      SPIR_trialsLoopScheduler.add(SPIR_trialsLoopEndIteration(SPIR_trialsLoopScheduler, snapshot));
    });
    
    return Scheduler.Event.NEXT;
  }
}


async function SPIR_trialsLoopEnd() {
  // terminate loop
  psychoJS.experiment.removeLoop(SPIR_trials);
  // update the current loop from the ExperimentHandler
  if (psychoJS.experiment._unfinishedLoops.length>0)
    currentLoop = psychoJS.experiment._unfinishedLoops.at(-1);
  else
    currentLoop = psychoJS.experiment;  // so we use addData from the experiment
  return Scheduler.Event.NEXT;
}


function SPIR_trialsLoopEndIteration(scheduler, snapshot) {
  // ------Prepare for next entry------
  return async function () {
    if (typeof snapshot !== 'undefined') {
      // ------Check if user ended loop early------
      if (snapshot.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(snapshot);
        }
        scheduler.stop();
      } else {
        psychoJS.experiment.nextEntry(snapshot);
      }
    return Scheduler.Event.NEXT;
    }
  };
}


var calibration_trialComponents;
function calibration_trialRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //--- Prepare to start Routine 'calibration_trial' ---
    t = 0;
    calibration_trialClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    // setup some python lists for storing info about the mouse_3
    mouse_3.clicked_name = [];
    gotValidClick = false; // until a click is received
    // Position calibration_square using width and height of window
    var canvas = psychoJS.window.size;
    var scaling = [
      canvas[0] <= canvas[1]? 1: canvas[0] / canvas[1],
      canvas[1] <= canvas[0]? 1: canvas[1] / canvas[0]
    ];
    var newPos = [
        calibration_x * scaling[0],
        calibration_y * scaling[1]
    ];
    console.log(newPos);
    calibration_square.setPos(newPos);
    // keep track of which components have finished
    calibration_trialComponents = [];
    calibration_trialComponents.push(calibration_square);
    calibration_trialComponents.push(mouse_3);
    
    calibration_trialComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


function calibration_trialRoutineEachFrame() {
  return async function () {
    //--- Loop for each frame of Routine 'calibration_trial' ---
    // get current time
    t = calibration_trialClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *calibration_square* updates
    if (t >= 0.0 && calibration_square.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      calibration_square.tStart = t;  // (not accounting for frame time here)
      calibration_square.frameNStart = frameN;  // exact frame index
      
      calibration_square.setAutoDraw(true);
    }

    // *mouse_3* updates
    if (t >= 0.0 && mouse_3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      mouse_3.tStart = t;  // (not accounting for frame time here)
      mouse_3.frameNStart = frameN;  // exact frame index
      
      mouse_3.status = PsychoJS.Status.STARTED;
      mouse_3.mouseClock.reset();
      prevButtonState = mouse_3.getPressed();  // if button is down already this ISN'T a new click
      }
    if (mouse_3.status === PsychoJS.Status.STARTED) {  // only update if started and not finished!
      _mouseButtons = mouse_3.getPressed();
      if (!_mouseButtons.every( (e,i,) => (e == prevButtonState[i]) )) { // button state changed?
        prevButtonState = _mouseButtons;
        if (_mouseButtons.reduce( (e, acc) => (e+acc) ) > 0) { // state changed to a new click
          // check if the mouse was inside our 'clickable' objects
          gotValidClick = false;
          for (const obj of [calibration_square]) {
            if (obj.contains(mouse_3)) {
              gotValidClick = true;
              mouse_3.clicked_name.push(obj.name)
            }
          }
          if (gotValidClick === true) { // abort routine on response
            continueRoutine = false;
          }
        }
      }
    }
    // Hide webcam thumbnail if eyes are in validation box
    if (webgazer.checkEyesInValidationBox() === true) {
      // If last time that eyes were outside of validation box was longer than 
      // window.eyesReturnedDelay ago, hide thumbnail
      if (
        document.getElementById('webgazerFaceFeedbackBox').style.display != 'none' &&
        (new Date).getTime() > window.eyesExitedTimestamp + window.eyesReturnedDelay
      ) {   
        document.getElementById('webgazerFaceFeedbackBox').style.display = 'none';
        document.getElementById('webgazerVideoFeed').style.display = 'none';
      }
    } else {
        // Eyes outside of validation box; show thumbnail
        window.eyesExitedTimestamp = (new Date).getTime();
        document.getElementById('webgazerFaceFeedbackBox').style.display = 'block';
        document.getElementById('webgazerVideoFeed').style.display = 'block';
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    calibration_trialComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function calibration_trialRoutineEnd(snapshot) {
  return async function () {
    //--- Ending Routine 'calibration_trial' ---
    calibration_trialComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // store data for psychoJS.experiment (ExperimentHandler)
    _mouseXYs = mouse_3.getPos();
    _mouseButtons = mouse_3.getPressed();
    psychoJS.experiment.addData('mouse_3.x', _mouseXYs[0]);
    psychoJS.experiment.addData('mouse_3.y', _mouseXYs[1]);
    psychoJS.experiment.addData('mouse_3.leftButton', _mouseButtons[0]);
    psychoJS.experiment.addData('mouse_3.midButton', _mouseButtons[1]);
    psychoJS.experiment.addData('mouse_3.rightButton', _mouseButtons[2]);
    if (mouse_3.clicked_name.length > 0) {
      psychoJS.experiment.addData('mouse_3.clicked_name', mouse_3.clicked_name[0]);}
    // the Routine "calibration_trial" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    // Routines running outside a loop should always advance the datafile row
    if (currentLoop === psychoJS.experiment) {
      psychoJS.experiment.nextEntry(snapshot);
    }
    return Scheduler.Event.NEXT;
  }
}


var _key_resp_allKeys;
var Opening_MAPComponents;
function Opening_MAPRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //--- Prepare to start Routine 'Opening_MAP' ---
    t = 0;
    Opening_MAPClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    key_resp.keys = undefined;
    key_resp.rt = undefined;
    _key_resp_allKeys = [];
    // Remove the click tracker used for calibration
    window.webgazer.removeMouseEventListeners();
    // keep track of which components have finished
    Opening_MAPComponents = [];
    Opening_MAPComponents.push(key_resp);
    Opening_MAPComponents.push(Instruct);
    Opening_MAPComponents.push(tracking_square_2);
    
    Opening_MAPComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


function Opening_MAPRoutineEachFrame() {
  return async function () {
    //--- Loop for each frame of Routine 'Opening_MAP' ---
    // get current time
    t = Opening_MAPClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *key_resp* updates
    if (t >= 0.0 && key_resp.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      key_resp.tStart = t;  // (not accounting for frame time here)
      key_resp.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { key_resp.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { key_resp.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { key_resp.clearEvents(); });
    }

    if (key_resp.status === PsychoJS.Status.STARTED) {
      let theseKeys = key_resp.getKeys({keyList: ['space'], waitRelease: false});
      _key_resp_allKeys = _key_resp_allKeys.concat(theseKeys);
      if (_key_resp_allKeys.length > 0) {
        key_resp.keys = _key_resp_allKeys[_key_resp_allKeys.length - 1].name;  // just the last key pressed
        key_resp.rt = _key_resp_allKeys[_key_resp_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    
    // *Instruct* updates
    if (t >= 0.0 && Instruct.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Instruct.tStart = t;  // (not accounting for frame time here)
      Instruct.frameNStart = frameN;  // exact frame index
      
      Instruct.setAutoDraw(true);
    }

    // Hide webcam thumbnail if eyes are in validation box
    if (webgazer.checkEyesInValidationBox() === true) {
      // If last time that eyes were outside of validation box was longer than 
      // window.eyesReturnedDelay ago, hide thumbnail
      if (
        document.getElementById('webgazerFaceFeedbackBox').style.display != 'none' &&
        (new Date).getTime() > window.eyesExitedTimestamp + window.eyesReturnedDelay
      ) {   
        document.getElementById('webgazerFaceFeedbackBox').style.display = 'none';
        document.getElementById('webgazerVideoFeed').style.display = 'none';
      }
    } else {
        // Eyes outside of validation box; show thumbnail
        window.eyesExitedTimestamp = (new Date).getTime();
        document.getElementById('webgazerFaceFeedbackBox').style.display = 'block';
        document.getElementById('webgazerVideoFeed').style.display = 'block';
    }
    // Update tracking square to the average of last n gazes
    let x = util.sum(window.xGazes) / window.xGazes.length;
    let y = util.sum(window.yGazes) / window.yGazes.length;
    // Set tracking square to x and y, transformed to height units
    tracking_square.setPos(
      util.to_height(
        [
          x - psychoJS.window.size[0] / 2,
          -1 * (y - psychoJS.window.size[1] / 2)
        ], 
        'pix', 
        psychoJS.window
      )
    );
    
    
    // *tracking_square_2* updates
    if (t >= 0.0 && tracking_square_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      tracking_square_2.tStart = t;  // (not accounting for frame time here)
      tracking_square_2.frameNStart = frameN;  // exact frame index
      
      tracking_square_2.setAutoDraw(true);
    }

    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    Opening_MAPComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function Opening_MAPRoutineEnd(snapshot) {
  return async function () {
    //--- Ending Routine 'Opening_MAP' ---
    Opening_MAPComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // update the trial handler
    if (currentLoop instanceof MultiStairHandler) {
      currentLoop.addResponse(key_resp.corr, level);
    }
    psychoJS.experiment.addData('key_resp.keys', key_resp.keys);
    if (typeof key_resp.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('key_resp.rt', key_resp.rt);
        routineTimer.reset();
        }
    
    key_resp.stop();
    // the Routine "Opening_MAP" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    // Routines running outside a loop should always advance the datafile row
    if (currentLoop === psychoJS.experiment) {
      psychoJS.experiment.nextEntry(snapshot);
    }
    return Scheduler.Event.NEXT;
  }
}


var isi;
var dur_cond;
var dur;
var Image_MAPComponents;
function Image_MAPRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //--- Prepare to start Routine 'Image_MAP' ---
    t = 0;
    Image_MAPClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    map_image.setImage(img_map);
    // Run 'Begin Routine' code from code_2
    isi = (np.random.randint(300, 500) / 100);
    console.log(isi);
    dur_cond = np.random.randint(1, 3);
    if ((dur_cond === 1)) {
        dur = 0.05;
    } else {
        if ((dur_cond === 2)) {
            dur = 0.3;
        } else {
            if ((dur_cond === 3)) {
                dur = 1;
            }
        }
    }
    console.log(dur_cond);
    console.log(dur);
    
    // Remove the click tracker used for calibration
    window.webgazer.removeMouseEventListeners();
    // keep track of which components have finished
    Image_MAPComponents = [];
    Image_MAPComponents.push(map_image);
    Image_MAPComponents.push(isi_crosshair);
    Image_MAPComponents.push(tracking_square_3);
    
    Image_MAPComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


var frameRemains;
function Image_MAPRoutineEachFrame() {
  return async function () {
    //--- Loop for each frame of Routine 'Image_MAP' ---
    // get current time
    t = Image_MAPClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *map_image* updates
    if (t >= (isi + 0.5) && map_image.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      map_image.tStart = t;  // (not accounting for frame time here)
      map_image.frameNStart = frameN;  // exact frame index
      
      map_image.setAutoDraw(true);
    }

    frameRemains = (isi + 0.5) + dur - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (map_image.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      map_image.setAutoDraw(false);
    }
    
    // *isi_crosshair* updates
    if (t >= 0.5 && isi_crosshair.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      isi_crosshair.tStart = t;  // (not accounting for frame time here)
      isi_crosshair.frameNStart = frameN;  // exact frame index
      
      isi_crosshair.setAutoDraw(true);
    }

    frameRemains = 0.5 + isi - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (isi_crosshair.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      isi_crosshair.setAutoDraw(false);
    }
    
    // *tracking_square_3* updates
    if (t >= 0.0 && tracking_square_3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      tracking_square_3.tStart = t;  // (not accounting for frame time here)
      tracking_square_3.frameNStart = frameN;  // exact frame index
      
      tracking_square_3.setAutoDraw(true);
    }

    // Hide webcam thumbnail if eyes are in validation box
    if (webgazer.checkEyesInValidationBox() === true) {
      // If last time that eyes were outside of validation box was longer than 
      // window.eyesReturnedDelay ago, hide thumbnail
      if (
        document.getElementById('webgazerFaceFeedbackBox').style.display != 'none' &&
        (new Date).getTime() > window.eyesExitedTimestamp + window.eyesReturnedDelay
      ) {   
        document.getElementById('webgazerFaceFeedbackBox').style.display = 'none';
        document.getElementById('webgazerVideoFeed').style.display = 'none';
      }
    } else {
        // Eyes outside of validation box; show thumbnail
        window.eyesExitedTimestamp = (new Date).getTime();
        document.getElementById('webgazerFaceFeedbackBox').style.display = 'block';
        document.getElementById('webgazerVideoFeed').style.display = 'block';
    }
    // Update tracking square to the average of last n gazes
    let x = util.sum(window.xGazes) / window.xGazes.length;
    let y = util.sum(window.yGazes) / window.yGazes.length;
    // Set tracking square to x and y, transformed to height units
    tracking_square.setPos(
      util.to_height(
        [
          x - psychoJS.window.size[0] / 2,
          -1 * (y - psychoJS.window.size[1] / 2)
        ], 
        'pix', 
        psychoJS.window
      )
    );
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    Image_MAPComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function Image_MAPRoutineEnd(snapshot) {
  return async function () {
    //--- Ending Routine 'Image_MAP' ---
    Image_MAPComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // the Routine "Image_MAP" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    // Routines running outside a loop should always advance the datafile row
    if (currentLoop === psychoJS.experiment) {
      psychoJS.experiment.nextEntry(snapshot);
    }
    return Scheduler.Event.NEXT;
  }
}


var backward_maskComponents;
function backward_maskRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //--- Prepare to start Routine 'backward_mask' ---
    t = 0;
    backward_maskClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    // Remove the click tracker used for calibration
    window.webgazer.removeMouseEventListeners();
    // keep track of which components have finished
    backward_maskComponents = [];
    backward_maskComponents.push(noise_img);
    backward_maskComponents.push(tracking_square_4);
    
    backward_maskComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


function backward_maskRoutineEachFrame() {
  return async function () {
    //--- Loop for each frame of Routine 'backward_mask' ---
    // get current time
    t = backward_maskClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *noise_img* updates
    if (t >= 0.0 && noise_img.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      noise_img.tStart = t;  // (not accounting for frame time here)
      noise_img.frameNStart = frameN;  // exact frame index
      
      noise_img.setAutoDraw(true);
    }

    frameRemains = 0.0 + 0.1 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (noise_img.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      noise_img.setAutoDraw(false);
    }
    
    // *tracking_square_4* updates
    if (t >= 0.0 && tracking_square_4.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      tracking_square_4.tStart = t;  // (not accounting for frame time here)
      tracking_square_4.frameNStart = frameN;  // exact frame index
      
      tracking_square_4.setAutoDraw(true);
    }

    // Hide webcam thumbnail if eyes are in validation box
    if (webgazer.checkEyesInValidationBox() === true) {
      // If last time that eyes were outside of validation box was longer than 
      // window.eyesReturnedDelay ago, hide thumbnail
      if (
        document.getElementById('webgazerFaceFeedbackBox').style.display != 'none' &&
        (new Date).getTime() > window.eyesExitedTimestamp + window.eyesReturnedDelay
      ) {   
        document.getElementById('webgazerFaceFeedbackBox').style.display = 'none';
        document.getElementById('webgazerVideoFeed').style.display = 'none';
      }
    } else {
        // Eyes outside of validation box; show thumbnail
        window.eyesExitedTimestamp = (new Date).getTime();
        document.getElementById('webgazerFaceFeedbackBox').style.display = 'block';
        document.getElementById('webgazerVideoFeed').style.display = 'block';
    }
    // Update tracking square to the average of last n gazes
    let x = util.sum(window.xGazes) / window.xGazes.length;
    let y = util.sum(window.yGazes) / window.yGazes.length;
    // Set tracking square to x and y, transformed to height units
    tracking_square.setPos(
      util.to_height(
        [
          x - psychoJS.window.size[0] / 2,
          -1 * (y - psychoJS.window.size[1] / 2)
        ], 
        'pix', 
        psychoJS.window
      )
    );
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    backward_maskComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function backward_maskRoutineEnd(snapshot) {
  return async function () {
    //--- Ending Routine 'backward_mask' ---
    backward_maskComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // the Routine "backward_mask" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    // Routines running outside a loop should always advance the datafile row
    if (currentLoop === psychoJS.experiment) {
      psychoJS.experiment.nextEntry(snapshot);
    }
    return Scheduler.Event.NEXT;
  }
}


var _key_resp_2_allKeys;
var rate_moral_MAPComponents;
function rate_moral_MAPRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //--- Prepare to start Routine 'rate_moral_MAP' ---
    t = 0;
    rate_moral_MAPClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    slider.reset()
    key_resp_2.keys = undefined;
    key_resp_2.rt = undefined;
    _key_resp_2_allKeys = [];
    // Remove the click tracker used for calibration
    window.webgazer.removeMouseEventListeners();
    // keep track of which components have finished
    rate_moral_MAPComponents = [];
    rate_moral_MAPComponents.push(moral_prompt);
    rate_moral_MAPComponents.push(slider);
    rate_moral_MAPComponents.push(moral_left);
    rate_moral_MAPComponents.push(moral_right);
    rate_moral_MAPComponents.push(key_resp_2);
    rate_moral_MAPComponents.push(enter_prompt);
    rate_moral_MAPComponents.push(tracking_square_5);
    
    rate_moral_MAPComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


function rate_moral_MAPRoutineEachFrame() {
  return async function () {
    //--- Loop for each frame of Routine 'rate_moral_MAP' ---
    // get current time
    t = rate_moral_MAPClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *moral_prompt* updates
    if (t >= 0.0 && moral_prompt.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      moral_prompt.tStart = t;  // (not accounting for frame time here)
      moral_prompt.frameNStart = frameN;  // exact frame index
      
      moral_prompt.setAutoDraw(true);
    }

    
    // *slider* updates
    if (t >= 0.0 && slider.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      slider.tStart = t;  // (not accounting for frame time here)
      slider.frameNStart = frameN;  // exact frame index
      
      slider.setAutoDraw(true);
    }

    
    // *moral_left* updates
    if (t >= 0.0 && moral_left.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      moral_left.tStart = t;  // (not accounting for frame time here)
      moral_left.frameNStart = frameN;  // exact frame index
      
      moral_left.setAutoDraw(true);
    }

    
    // *moral_right* updates
    if (t >= 0.0 && moral_right.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      moral_right.tStart = t;  // (not accounting for frame time here)
      moral_right.frameNStart = frameN;  // exact frame index
      
      moral_right.setAutoDraw(true);
    }

    
    // *key_resp_2* updates
    if (t >= 0.0 && key_resp_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      key_resp_2.tStart = t;  // (not accounting for frame time here)
      key_resp_2.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { key_resp_2.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { key_resp_2.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { key_resp_2.clearEvents(); });
    }

    if (key_resp_2.status === PsychoJS.Status.STARTED) {
      let theseKeys = key_resp_2.getKeys({keyList: ['space', 'enter'], waitRelease: false});
      _key_resp_2_allKeys = _key_resp_2_allKeys.concat(theseKeys);
      if (_key_resp_2_allKeys.length > 0) {
        key_resp_2.keys = _key_resp_2_allKeys[_key_resp_2_allKeys.length - 1].name;  // just the last key pressed
        key_resp_2.rt = _key_resp_2_allKeys[_key_resp_2_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    
    // *enter_prompt* updates
    if (t >= 0.0 && enter_prompt.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      enter_prompt.tStart = t;  // (not accounting for frame time here)
      enter_prompt.frameNStart = frameN;  // exact frame index
      
      enter_prompt.setAutoDraw(true);
    }

    
    // *tracking_square_5* updates
    if (t >= 0.0 && tracking_square_5.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      tracking_square_5.tStart = t;  // (not accounting for frame time here)
      tracking_square_5.frameNStart = frameN;  // exact frame index
      
      tracking_square_5.setAutoDraw(true);
    }

    // Hide webcam thumbnail if eyes are in validation box
    if (webgazer.checkEyesInValidationBox() === true) {
      // If last time that eyes were outside of validation box was longer than 
      // window.eyesReturnedDelay ago, hide thumbnail
      if (
        document.getElementById('webgazerFaceFeedbackBox').style.display != 'none' &&
        (new Date).getTime() > window.eyesExitedTimestamp + window.eyesReturnedDelay
      ) {   
        document.getElementById('webgazerFaceFeedbackBox').style.display = 'none';
        document.getElementById('webgazerVideoFeed').style.display = 'none';
      }
    } else {
        // Eyes outside of validation box; show thumbnail
        window.eyesExitedTimestamp = (new Date).getTime();
        document.getElementById('webgazerFaceFeedbackBox').style.display = 'block';
        document.getElementById('webgazerVideoFeed').style.display = 'block';
    }
    // Update tracking square to the average of last n gazes
    let x = util.sum(window.xGazes) / window.xGazes.length;
    let y = util.sum(window.yGazes) / window.yGazes.length;
    // Set tracking square to x and y, transformed to height units
    tracking_square.setPos(
      util.to_height(
        [
          x - psychoJS.window.size[0] / 2,
          -1 * (y - psychoJS.window.size[1] / 2)
        ], 
        'pix', 
        psychoJS.window
      )
    );
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    rate_moral_MAPComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function rate_moral_MAPRoutineEnd(snapshot) {
  return async function () {
    //--- Ending Routine 'rate_moral_MAP' ---
    rate_moral_MAPComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    psychoJS.experiment.addData('slider.response', slider.getRating());
    psychoJS.experiment.addData('slider.rt', slider.getRT());
    // update the trial handler
    if (currentLoop instanceof MultiStairHandler) {
      currentLoop.addResponse(key_resp_2.corr, level);
    }
    psychoJS.experiment.addData('key_resp_2.keys', key_resp_2.keys);
    if (typeof key_resp_2.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('key_resp_2.rt', key_resp_2.rt);
        routineTimer.reset();
        }
    
    key_resp_2.stop();
    // the Routine "rate_moral_MAP" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    // Routines running outside a loop should always advance the datafile row
    if (currentLoop === psychoJS.experiment) {
      psychoJS.experiment.nextEntry(snapshot);
    }
    return Scheduler.Event.NEXT;
  }
}


var _key_resp_3_allKeys;
var rate_confidence_MAPComponents;
function rate_confidence_MAPRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //--- Prepare to start Routine 'rate_confidence_MAP' ---
    t = 0;
    rate_confidence_MAPClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    slider_2.reset()
    key_resp_3.keys = undefined;
    key_resp_3.rt = undefined;
    _key_resp_3_allKeys = [];
    // Remove the click tracker used for calibration
    window.webgazer.removeMouseEventListeners();
    // keep track of which components have finished
    rate_confidence_MAPComponents = [];
    rate_confidence_MAPComponents.push(moral_confidence);
    rate_confidence_MAPComponents.push(slider_2);
    rate_confidence_MAPComponents.push(conf_left);
    rate_confidence_MAPComponents.push(conf_right);
    rate_confidence_MAPComponents.push(key_resp_3);
    rate_confidence_MAPComponents.push(enter_prompt2);
    rate_confidence_MAPComponents.push(tracking_square_6);
    
    rate_confidence_MAPComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


function rate_confidence_MAPRoutineEachFrame() {
  return async function () {
    //--- Loop for each frame of Routine 'rate_confidence_MAP' ---
    // get current time
    t = rate_confidence_MAPClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *moral_confidence* updates
    if (t >= 0.0 && moral_confidence.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      moral_confidence.tStart = t;  // (not accounting for frame time here)
      moral_confidence.frameNStart = frameN;  // exact frame index
      
      moral_confidence.setAutoDraw(true);
    }

    
    // *slider_2* updates
    if (t >= 0.0 && slider_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      slider_2.tStart = t;  // (not accounting for frame time here)
      slider_2.frameNStart = frameN;  // exact frame index
      
      slider_2.setAutoDraw(true);
    }

    
    // *conf_left* updates
    if (t >= 0.0 && conf_left.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      conf_left.tStart = t;  // (not accounting for frame time here)
      conf_left.frameNStart = frameN;  // exact frame index
      
      conf_left.setAutoDraw(true);
    }

    
    // *conf_right* updates
    if (t >= 0.0 && conf_right.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      conf_right.tStart = t;  // (not accounting for frame time here)
      conf_right.frameNStart = frameN;  // exact frame index
      
      conf_right.setAutoDraw(true);
    }

    
    // *key_resp_3* updates
    if (t >= 0.0 && key_resp_3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      key_resp_3.tStart = t;  // (not accounting for frame time here)
      key_resp_3.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { key_resp_3.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { key_resp_3.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { key_resp_3.clearEvents(); });
    }

    if (key_resp_3.status === PsychoJS.Status.STARTED) {
      let theseKeys = key_resp_3.getKeys({keyList: ['space', 'enter'], waitRelease: false});
      _key_resp_3_allKeys = _key_resp_3_allKeys.concat(theseKeys);
      if (_key_resp_3_allKeys.length > 0) {
        key_resp_3.keys = _key_resp_3_allKeys[_key_resp_3_allKeys.length - 1].name;  // just the last key pressed
        key_resp_3.rt = _key_resp_3_allKeys[_key_resp_3_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    
    // *enter_prompt2* updates
    if (t >= 0.0 && enter_prompt2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      enter_prompt2.tStart = t;  // (not accounting for frame time here)
      enter_prompt2.frameNStart = frameN;  // exact frame index
      
      enter_prompt2.setAutoDraw(true);
    }

    
    // *tracking_square_6* updates
    if (t >= 0.0 && tracking_square_6.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      tracking_square_6.tStart = t;  // (not accounting for frame time here)
      tracking_square_6.frameNStart = frameN;  // exact frame index
      
      tracking_square_6.setAutoDraw(true);
    }

    // Hide webcam thumbnail if eyes are in validation box
    if (webgazer.checkEyesInValidationBox() === true) {
      // If last time that eyes were outside of validation box was longer than 
      // window.eyesReturnedDelay ago, hide thumbnail
      if (
        document.getElementById('webgazerFaceFeedbackBox').style.display != 'none' &&
        (new Date).getTime() > window.eyesExitedTimestamp + window.eyesReturnedDelay
      ) {   
        document.getElementById('webgazerFaceFeedbackBox').style.display = 'none';
        document.getElementById('webgazerVideoFeed').style.display = 'none';
      }
    } else {
        // Eyes outside of validation box; show thumbnail
        window.eyesExitedTimestamp = (new Date).getTime();
        document.getElementById('webgazerFaceFeedbackBox').style.display = 'block';
        document.getElementById('webgazerVideoFeed').style.display = 'block';
    }
    // Update tracking square to the average of last n gazes
    let x = util.sum(window.xGazes) / window.xGazes.length;
    let y = util.sum(window.yGazes) / window.yGazes.length;
    // Set tracking square to x and y, transformed to height units
    tracking_square.setPos(
      util.to_height(
        [
          x - psychoJS.window.size[0] / 2,
          -1 * (y - psychoJS.window.size[1] / 2)
        ], 
        'pix', 
        psychoJS.window
      )
    );
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    rate_confidence_MAPComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function rate_confidence_MAPRoutineEnd(snapshot) {
  return async function () {
    //--- Ending Routine 'rate_confidence_MAP' ---
    rate_confidence_MAPComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    psychoJS.experiment.addData('slider_2.response', slider_2.getRating());
    psychoJS.experiment.addData('slider_2.rt', slider_2.getRT());
    // update the trial handler
    if (currentLoop instanceof MultiStairHandler) {
      currentLoop.addResponse(key_resp_3.corr, level);
    }
    psychoJS.experiment.addData('key_resp_3.keys', key_resp_3.keys);
    if (typeof key_resp_3.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('key_resp_3.rt', key_resp_3.rt);
        routineTimer.reset();
        }
    
    key_resp_3.stop();
    // the Routine "rate_confidence_MAP" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    // Routines running outside a loop should always advance the datafile row
    if (currentLoop === psychoJS.experiment) {
      psychoJS.experiment.nextEntry(snapshot);
    }
    return Scheduler.Event.NEXT;
  }
}


var _key_resp_4_allKeys;
var End_MAPComponents;
function End_MAPRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //--- Prepare to start Routine 'End_MAP' ---
    t = 0;
    End_MAPClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    key_resp_4.keys = undefined;
    key_resp_4.rt = undefined;
    _key_resp_4_allKeys = [];
    // keep track of which components have finished
    End_MAPComponents = [];
    End_MAPComponents.push(text);
    End_MAPComponents.push(key_resp_4);
    
    End_MAPComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


function End_MAPRoutineEachFrame() {
  return async function () {
    //--- Loop for each frame of Routine 'End_MAP' ---
    // get current time
    t = End_MAPClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *text* updates
    if (t >= 0.0 && text.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      text.tStart = t;  // (not accounting for frame time here)
      text.frameNStart = frameN;  // exact frame index
      
      text.setAutoDraw(true);
    }

    
    // *key_resp_4* updates
    if (t >= 0.0 && key_resp_4.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      key_resp_4.tStart = t;  // (not accounting for frame time here)
      key_resp_4.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { key_resp_4.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { key_resp_4.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { key_resp_4.clearEvents(); });
    }

    if (key_resp_4.status === PsychoJS.Status.STARTED) {
      let theseKeys = key_resp_4.getKeys({keyList: ['space'], waitRelease: false});
      _key_resp_4_allKeys = _key_resp_4_allKeys.concat(theseKeys);
      if (_key_resp_4_allKeys.length > 0) {
        key_resp_4.keys = _key_resp_4_allKeys[_key_resp_4_allKeys.length - 1].name;  // just the last key pressed
        key_resp_4.rt = _key_resp_4_allKeys[_key_resp_4_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    End_MAPComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function End_MAPRoutineEnd(snapshot) {
  return async function () {
    //--- Ending Routine 'End_MAP' ---
    End_MAPComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // update the trial handler
    if (currentLoop instanceof MultiStairHandler) {
      currentLoop.addResponse(key_resp_4.corr, level);
    }
    psychoJS.experiment.addData('key_resp_4.keys', key_resp_4.keys);
    if (typeof key_resp_4.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('key_resp_4.rt', key_resp_4.rt);
        routineTimer.reset();
        }
    
    key_resp_4.stop();
    // the Routine "End_MAP" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    // Routines running outside a loop should always advance the datafile row
    if (currentLoop === psychoJS.experiment) {
      psychoJS.experiment.nextEntry(snapshot);
    }
    return Scheduler.Event.NEXT;
  }
}


var _key_resp_5_allKeys;
var Opening_SPIRComponents;
function Opening_SPIRRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //--- Prepare to start Routine 'Opening_SPIR' ---
    t = 0;
    Opening_SPIRClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    key_resp_5.keys = undefined;
    key_resp_5.rt = undefined;
    _key_resp_5_allKeys = [];
    // keep track of which components have finished
    Opening_SPIRComponents = [];
    Opening_SPIRComponents.push(inst_SPIR);
    Opening_SPIRComponents.push(key_resp_5);
    
    Opening_SPIRComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


function Opening_SPIRRoutineEachFrame() {
  return async function () {
    //--- Loop for each frame of Routine 'Opening_SPIR' ---
    // get current time
    t = Opening_SPIRClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *inst_SPIR* updates
    if (t >= 0.0 && inst_SPIR.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      inst_SPIR.tStart = t;  // (not accounting for frame time here)
      inst_SPIR.frameNStart = frameN;  // exact frame index
      
      inst_SPIR.setAutoDraw(true);
    }

    
    // *key_resp_5* updates
    if (t >= 0.0 && key_resp_5.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      key_resp_5.tStart = t;  // (not accounting for frame time here)
      key_resp_5.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { key_resp_5.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { key_resp_5.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { key_resp_5.clearEvents(); });
    }

    if (key_resp_5.status === PsychoJS.Status.STARTED) {
      let theseKeys = key_resp_5.getKeys({keyList: ['space'], waitRelease: false});
      _key_resp_5_allKeys = _key_resp_5_allKeys.concat(theseKeys);
      if (_key_resp_5_allKeys.length > 0) {
        key_resp_5.keys = _key_resp_5_allKeys[_key_resp_5_allKeys.length - 1].name;  // just the last key pressed
        key_resp_5.rt = _key_resp_5_allKeys[_key_resp_5_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    Opening_SPIRComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function Opening_SPIRRoutineEnd(snapshot) {
  return async function () {
    //--- Ending Routine 'Opening_SPIR' ---
    Opening_SPIRComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // update the trial handler
    if (currentLoop instanceof MultiStairHandler) {
      currentLoop.addResponse(key_resp_5.corr, level);
    }
    psychoJS.experiment.addData('key_resp_5.keys', key_resp_5.keys);
    if (typeof key_resp_5.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('key_resp_5.rt', key_resp_5.rt);
        routineTimer.reset();
        }
    
    key_resp_5.stop();
    // the Routine "Opening_SPIR" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    // Routines running outside a loop should always advance the datafile row
    if (currentLoop === psychoJS.experiment) {
      psychoJS.experiment.nextEntry(snapshot);
    }
    return Scheduler.Event.NEXT;
  }
}


var _key_resp_6_allKeys;
var rating_SPIRComponents;
function rating_SPIRRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //--- Prepare to start Routine 'rating_SPIR' ---
    t = 0;
    rating_SPIRClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    moral_slider.reset()
    key_resp_6.keys = undefined;
    key_resp_6.rt = undefined;
    _key_resp_6_allKeys = [];
    valence_slider.reset()
    arous_slider.reset()
    image_spir.setImage(img_spir);
    // keep track of which components have finished
    rating_SPIRComponents = [];
    rating_SPIRComponents.push(moral_prompt_2);
    rating_SPIRComponents.push(moral_slider);
    rating_SPIRComponents.push(moral_left_2);
    rating_SPIRComponents.push(moral_right_2);
    rating_SPIRComponents.push(key_resp_6);
    rating_SPIRComponents.push(enter_prompt_2);
    rating_SPIRComponents.push(valence_left);
    rating_SPIRComponents.push(valence_right);
    rating_SPIRComponents.push(valence_slider);
    rating_SPIRComponents.push(arous_left);
    rating_SPIRComponents.push(arous_right);
    rating_SPIRComponents.push(arous_slider);
    rating_SPIRComponents.push(image_spir);
    
    rating_SPIRComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


function rating_SPIRRoutineEachFrame() {
  return async function () {
    //--- Loop for each frame of Routine 'rating_SPIR' ---
    // get current time
    t = rating_SPIRClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *moral_prompt_2* updates
    if (t >= 0.0 && moral_prompt_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      moral_prompt_2.tStart = t;  // (not accounting for frame time here)
      moral_prompt_2.frameNStart = frameN;  // exact frame index
      
      moral_prompt_2.setAutoDraw(true);
    }

    
    // *moral_slider* updates
    if (t >= 0.0 && moral_slider.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      moral_slider.tStart = t;  // (not accounting for frame time here)
      moral_slider.frameNStart = frameN;  // exact frame index
      
      moral_slider.setAutoDraw(true);
    }

    
    // *moral_left_2* updates
    if (t >= 0.0 && moral_left_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      moral_left_2.tStart = t;  // (not accounting for frame time here)
      moral_left_2.frameNStart = frameN;  // exact frame index
      
      moral_left_2.setAutoDraw(true);
    }

    
    // *moral_right_2* updates
    if (t >= 0.0 && moral_right_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      moral_right_2.tStart = t;  // (not accounting for frame time here)
      moral_right_2.frameNStart = frameN;  // exact frame index
      
      moral_right_2.setAutoDraw(true);
    }

    
    // *key_resp_6* updates
    if (t >= 0.0 && key_resp_6.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      key_resp_6.tStart = t;  // (not accounting for frame time here)
      key_resp_6.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { key_resp_6.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { key_resp_6.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { key_resp_6.clearEvents(); });
    }

    if (key_resp_6.status === PsychoJS.Status.STARTED) {
      let theseKeys = key_resp_6.getKeys({keyList: ['space', 'enter'], waitRelease: false});
      _key_resp_6_allKeys = _key_resp_6_allKeys.concat(theseKeys);
      if (_key_resp_6_allKeys.length > 0) {
        key_resp_6.keys = _key_resp_6_allKeys[_key_resp_6_allKeys.length - 1].name;  // just the last key pressed
        key_resp_6.rt = _key_resp_6_allKeys[_key_resp_6_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    
    // *enter_prompt_2* updates
    if (t >= 0.0 && enter_prompt_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      enter_prompt_2.tStart = t;  // (not accounting for frame time here)
      enter_prompt_2.frameNStart = frameN;  // exact frame index
      
      enter_prompt_2.setAutoDraw(true);
    }

    
    // *valence_left* updates
    if (t >= 0.0 && valence_left.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      valence_left.tStart = t;  // (not accounting for frame time here)
      valence_left.frameNStart = frameN;  // exact frame index
      
      valence_left.setAutoDraw(true);
    }

    
    // *valence_right* updates
    if (t >= 0.0 && valence_right.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      valence_right.tStart = t;  // (not accounting for frame time here)
      valence_right.frameNStart = frameN;  // exact frame index
      
      valence_right.setAutoDraw(true);
    }

    
    // *valence_slider* updates
    if (t >= 0.0 && valence_slider.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      valence_slider.tStart = t;  // (not accounting for frame time here)
      valence_slider.frameNStart = frameN;  // exact frame index
      
      valence_slider.setAutoDraw(true);
    }

    
    // *arous_left* updates
    if (t >= 0.0 && arous_left.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      arous_left.tStart = t;  // (not accounting for frame time here)
      arous_left.frameNStart = frameN;  // exact frame index
      
      arous_left.setAutoDraw(true);
    }

    
    // *arous_right* updates
    if (t >= 0.0 && arous_right.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      arous_right.tStart = t;  // (not accounting for frame time here)
      arous_right.frameNStart = frameN;  // exact frame index
      
      arous_right.setAutoDraw(true);
    }

    
    // *arous_slider* updates
    if (t >= 0.0 && arous_slider.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      arous_slider.tStart = t;  // (not accounting for frame time here)
      arous_slider.frameNStart = frameN;  // exact frame index
      
      arous_slider.setAutoDraw(true);
    }

    
    // *image_spir* updates
    if (t >= 0.0 && image_spir.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      image_spir.tStart = t;  // (not accounting for frame time here)
      image_spir.frameNStart = frameN;  // exact frame index
      
      image_spir.setAutoDraw(true);
    }

    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    rating_SPIRComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function rating_SPIRRoutineEnd(snapshot) {
  return async function () {
    //--- Ending Routine 'rating_SPIR' ---
    rating_SPIRComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    psychoJS.experiment.addData('moral_slider.response', moral_slider.getRating());
    psychoJS.experiment.addData('moral_slider.rt', moral_slider.getRT());
    // update the trial handler
    if (currentLoop instanceof MultiStairHandler) {
      currentLoop.addResponse(key_resp_6.corr, level);
    }
    psychoJS.experiment.addData('key_resp_6.keys', key_resp_6.keys);
    if (typeof key_resp_6.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('key_resp_6.rt', key_resp_6.rt);
        routineTimer.reset();
        }
    
    key_resp_6.stop();
    psychoJS.experiment.addData('valence_slider.response', valence_slider.getRating());
    psychoJS.experiment.addData('valence_slider.rt', valence_slider.getRT());
    psychoJS.experiment.addData('arous_slider.response', arous_slider.getRating());
    psychoJS.experiment.addData('arous_slider.rt', arous_slider.getRT());
    // the Routine "rating_SPIR" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    // Routines running outside a loop should always advance the datafile row
    if (currentLoop === psychoJS.experiment) {
      psychoJS.experiment.nextEntry(snapshot);
    }
    return Scheduler.Event.NEXT;
  }
}


var _key_resp_7_allKeys;
var End_SPIRComponents;
function End_SPIRRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //--- Prepare to start Routine 'End_SPIR' ---
    t = 0;
    End_SPIRClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    key_resp_7.keys = undefined;
    key_resp_7.rt = undefined;
    _key_resp_7_allKeys = [];
    // keep track of which components have finished
    End_SPIRComponents = [];
    End_SPIRComponents.push(text_2);
    End_SPIRComponents.push(key_resp_7);
    
    End_SPIRComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


function End_SPIRRoutineEachFrame() {
  return async function () {
    //--- Loop for each frame of Routine 'End_SPIR' ---
    // get current time
    t = End_SPIRClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *text_2* updates
    if (t >= 0.0 && text_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      text_2.tStart = t;  // (not accounting for frame time here)
      text_2.frameNStart = frameN;  // exact frame index
      
      text_2.setAutoDraw(true);
    }

    
    // *key_resp_7* updates
    if (t >= 0.0 && key_resp_7.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      key_resp_7.tStart = t;  // (not accounting for frame time here)
      key_resp_7.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { key_resp_7.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { key_resp_7.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { key_resp_7.clearEvents(); });
    }

    if (key_resp_7.status === PsychoJS.Status.STARTED) {
      let theseKeys = key_resp_7.getKeys({keyList: ['space'], waitRelease: false});
      _key_resp_7_allKeys = _key_resp_7_allKeys.concat(theseKeys);
      if (_key_resp_7_allKeys.length > 0) {
        key_resp_7.keys = _key_resp_7_allKeys[_key_resp_7_allKeys.length - 1].name;  // just the last key pressed
        key_resp_7.rt = _key_resp_7_allKeys[_key_resp_7_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    End_SPIRComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function End_SPIRRoutineEnd(snapshot) {
  return async function () {
    //--- Ending Routine 'End_SPIR' ---
    End_SPIRComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // update the trial handler
    if (currentLoop instanceof MultiStairHandler) {
      currentLoop.addResponse(key_resp_7.corr, level);
    }
    psychoJS.experiment.addData('key_resp_7.keys', key_resp_7.keys);
    if (typeof key_resp_7.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('key_resp_7.rt', key_resp_7.rt);
        routineTimer.reset();
        }
    
    key_resp_7.stop();
    // the Routine "End_SPIR" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    // Routines running outside a loop should always advance the datafile row
    if (currentLoop === psychoJS.experiment) {
      psychoJS.experiment.nextEntry(snapshot);
    }
    return Scheduler.Event.NEXT;
  }
}


function importConditions(currentLoop) {
  return async function () {
    psychoJS.importAttributes(currentLoop.getCurrentTrial());
    return Scheduler.Event.NEXT;
    };
}


async function quitPsychoJS(message, isCompleted) {
  // Check for and save orphaned data
  if (psychoJS.experiment.isEntryEmpty()) {
    psychoJS.experiment.nextEntry();
  }
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  psychoJS.window.close();
  psychoJS.quit({message: message, isCompleted: isCompleted});
  
  return Scheduler.Event.QUIT;
}
